Scala Reflection Library2.13.5 < Back


# Packages

-  package root
  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package api

  EXPERIMENTAL

  EXPERIMENTAL

  The Scala Reflection API (located in scala-reflect.jar).

  In Scala 2.10.0, the Scala Reflection API and its implementation have an "experimental" status. This means that the API and the docs are not complete and can be changed in binary- and source-incompatible manner in 2.10.1. This also means that the implementation has some known issues.

  The following types are the backbone of the Scala Reflection API, and serve as a good starting point for information about Scala Reflection:

  - scala.reflect.api.Symbols
  - scala.reflect.api.Types
  - scala.reflect.api.Mirrors
  - scala.reflect.api.Universe

  For more information about Scala Reflection, see the Reflection Guide

  Definition Classes
    reflect
-  trait Trees extends AnyRef

  EXPERIMENTAL

  EXPERIMENTAL

  This trait defines the node types used in Scala abstract syntax trees (AST) and operations on them.

  Trees are the basis for Scala's abstract syntax that is used to represent programs. They are also called abstract syntax trees and commonly abbreviated as ASTs.

  In Scala reflection, APIs that produce or use `Tree`s are:

  - Annotations which use trees to represent their arguments, exposed in Annotation.scalaArgs.
  - reify, a special method on scala.reflect.api.Universe that takes an expression and returns an AST which represents the expression.
  - Macros and runtime compilation with toolboxes which both use trees as their program representation medium.

  Trees are immutable, except for three fields pos, symbol, and tpe, which are assigned when a tree is typechecked to attribute it with the information gathered by the typechecker.

  ##### Examples

  The following creates an AST representing a literal 5 in Scala source code:

      Literal(Constant(5))

  The following creates an AST representing `print("Hello World")`:

      Apply(Select(Select(This(TypeName("scala")), TermName("Predef")), TermName("print")), List(Literal(Constant("Hello World"))))

  The following creates an AST from a literal 5, and then uses `showRaw` to print it in a readable format.

      import scala.reflect.runtime.universe.{ reify, showRaw }
      print( showRaw( reify{5}.tree ) )` // prints Literal(Constant(5))

  For more information about `Tree`s, see the Reflection Guide: Symbols, Trees, Types.

  Definition Classes
    api
- Alternative
- AlternativeApi
- AlternativeExtractor
- Annotated
- AnnotatedApi
- AnnotatedExtractor
- AppliedTypeTree
- AppliedTypeTreeApi
- AppliedTypeTreeExtractor
- Apply
- ApplyApi
- ApplyExtractor
- Assign
- AssignApi
- AssignExtractor
- Bind
- BindApi
- BindExtractor
- Block
- BlockApi
- BlockExtractor
- CaseDef
- CaseDefApi
- CaseDefExtractor
- ClassDef
- ClassDefApi
- ClassDefExtractor
- CompoundTypeTree
- CompoundTypeTreeApi
- CompoundTypeTreeExtractor
- DefDef
- DefDefApi
- DefDefExtractor
- DefTree
- DefTreeApi
- ExistentialTypeTree
- ExistentialTypeTreeApi
- ExistentialTypeTreeExtractor
- Function
- FunctionApi
- FunctionExtractor
- GenericApply
- GenericApplyApi
- Ident
- IdentApi
- IdentExtractor
- If
- IfApi
- IfExtractor
- ImplDef
- ImplDefApi
- Import
- ImportApi
- ImportExtractor
- ImportSelector
- ImportSelectorApi
- ImportSelectorExtractor
- LabelDef
- LabelDefApi
- LabelDefExtractor
- Literal
- LiteralApi
- LiteralExtractor
- Match
- MatchApi
- MatchExtractor
- MemberDef
- MemberDefApi
- Modifiers
- ModifiersApi
- ModifiersExtractor
- ModuleDef
- ModuleDefApi
- ModuleDefExtractor
- NameTree
- NameTreeApi
- NamedArg
- NamedArgApi
- NamedArgExtractor
- New
- NewApi
- NewExtractor
- PackageDef
- PackageDefApi
- PackageDefExtractor
- RefTree
- RefTreeApi
- RefTreeExtractor
- Return
- ReturnApi
- ReturnExtractor
- Select
- SelectApi
- SelectExtractor
- SelectFromTypeTree
- SelectFromTypeTreeApi
- SelectFromTypeTreeExtractor
- SingletonTypeTree
- SingletonTypeTreeApi
- SingletonTypeTreeExtractor
- Star
- StarApi
- StarExtractor
- Super
- SuperApi
- SuperExtractor
- SymTree
- SymTreeApi
- Template
- TemplateApi
- TemplateExtractor
- TermTree
- TermTreeApi
- This
- ThisApi
- ThisExtractor
- Throw
- ThrowApi
- ThrowExtractor
- Transformer
- Traverser
- Tree
- TreeApi
- TreeCopier
- TreeCopierOps
- Try
- TryApi
- TryExtractor
- TypTree
- TypTreeApi
- TypeApply
- TypeApplyApi
- TypeApplyExtractor
- TypeBoundsTree
- TypeBoundsTreeApi
- TypeBoundsTreeExtractor
- TypeDef
- TypeDefApi
- TypeDefExtractor
- TypeTree
- TypeTreeApi
- TypeTreeExtractor
- Typed
- TypedApi
- TypedExtractor
- UnApply
- UnApplyApi
- UnApplyExtractor
- ValDef
- ValDefApi
- ValDefExtractor
- ValOrDefDef
- ValOrDefDefApi

a

scala.reflect.api.Trees

# ImportSelector

###
Companion class ImportSelectorExtractor

#### abstract type ImportSelector >: Null <: Universe.ImportSelectorApi

Import selector (not a tree, but a component of the `Import` tree)

Representation of an imported name its optional rename and their optional positions

Eliminated by typecheck.

Source
  Trees.scala

Linear Supertypes
Universe.ImportSelectorApi, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ImportSelector
2. ImportSelectorApi
3. AnyRef
4. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Abstract Value Members

1.  abstract def isMask: Boolean

   Does the selector mask or hide a name? `import x.{y => _}`

   Does the selector mask or hide a name? `import x.{y => _}`

   Definition Classes
     ImportSelectorApi
2.  abstract def isRename: Boolean

   Does the selector introduce a specific name by rename? `x.{y => z}`

   Does the selector introduce a specific name by rename? `x.{y => z}`

   Definition Classes
     ImportSelectorApi
3.  abstract def isSpecific: Boolean

   Does the selector introduce a specific name? `import a.b, x.{y => z}`

   Does the selector introduce a specific name? `import a.b, x.{y => z}`

   Definition Classes
     ImportSelectorApi
4.  abstract def isWildcard: Boolean

   Is the selector a wildcard import that introduces all available names? `import x._`

   Is the selector a wildcard import that introduces all available names? `import x._`

   Definition Classes
     ImportSelectorApi
5.  abstract def name: Universe.Name

   The imported name.

   The imported name.

   Definition Classes
     ImportSelectorApi
6.  abstract def namePos: Int

   Offset of the position of the importing part of the selector in the source file.

   Offset of the position of the importing part of the selector in the source file. Is equal to -1 is the position is unknown.

   Definition Classes
     ImportSelectorApi
7.  abstract def rename: Universe.Name

   The name the import is renamed to.

   The name the import is renamed to. Is equal to `name` if it's not a renaming import.

   Definition Classes
     ImportSelectorApi
8.  abstract def renamePos: Int

   Offset of the position of the renaming part of the selector in the source file.

   Offset of the position of the renaming part of the selector in the source file. Is equal to -1 is the position is unknown.

   Definition Classes
     ImportSelectorApi

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
5.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
6.  final def eq(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef
7.  def equals(arg0: AnyRef): Boolean
   Definition Classes
     AnyRef → Any
8.  def finalize(): Unit
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.Throwable])
9.  final def getClass(): Class[_ <: AnyRef]
   Definition Classes
     AnyRef → Any
   Annotations
     @native()
10.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
11.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
12.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
14.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
15.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
16.  def toString(): String
    Definition Classes
      AnyRef → Any
17.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
18.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
19.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Inherited from Universe.ImportSelectorApi

### Inherited from AnyRef

### Inherited from Any

### Ungrouped